<?php
defined('TYPO3') || die('Access denied.');

\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPItoST43('ig_account_create', 'pi1/class.tx_igaccountcreate_pi1.php', '_pi1', 'list_type', 0);

call_user_func(
    function()
    {

        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgAccountCreate',
            'Form',
            [
                \Ig\IgAccountCreate\Controller\AccountController::class => 'register'
            ],
            // non-cacheable actions
            [
                \Ig\IgAccountCreate\Controller\AccountController::class => 'register'
            ]
        );
        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::configurePlugin(
            'IgAccountCreate',
            'Confirm',
            [
                \Ig\IgAccountCreate\Controller\AccountController::class => 'confirm, data'
            ],
            // non-cacheable actions
            [
                \Ig\IgAccountCreate\Controller\AccountController::class => 'confirm, data'
            ]
        );

$iconRegistry = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Imaging\IconRegistry::class);
 
 
        
    // wizards
    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPageTSConfig(
        'mod {
            wizards.newContentElement.wizardItems.plugins {
                elements {
                    form {
                        iconIdentifier = ig_account_create-plugin-form
                        title = LLL:EXT:ig_account_create/Resources/Private/Language/locallang_db.xlf:tx_ig_account_create_form.name
                        description = LLL:EXT:ig_account_create/Resources/Private/Language/locallang_db.xlf:tx_ig_account_create_form.description
                        tt_content_defValues {
                            CType = list
                            list_type = igaccountcreate_form
                        }
                    }
                }
                show = *
            }
       }'
    );
		$iconRegistry = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Imaging\IconRegistry::class);
		
			$iconRegistry->registerIcon(
				'ig_account_create-plugin-form',
				\TYPO3\CMS\Core\Imaging\IconProvider\SvgIconProvider::class,
				['source' => 'EXT:ig_account_create/Resources/Public/Icons/user_plugin_form.svg']
			);
		
    }
);


$GLOBALS['TYPO3_CONF_VARS']['MAIL']['templateRootPaths'][1900] = 'EXT:ig_account_create/Resources/Private/Email/Templates/';
$GLOBALS['TYPO3_CONF_VARS']['MAIL']['partialRootPaths'][1900] = 'EXT:ig_account_create/Resources/Private/Email/Partials/';