<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2012 Daniel Abplanalp <typo3@internetgalerie.ch>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

// //////require_once(PATH_tslib . 'class.tslib_pibase.php');

/**
 * Plugin 'Cashback Anmeldung' for the 'ig_cashback_register' extension.
 *
 * @author	Daniel Abplanalp <typo3@internetgalerie.ch>
 * @package	TYPO3
 * @subpackage	tx_igcashbackregister
 */
class tx_igcashbackregister_pi1 extends \TYPO3\CMS\Frontend\Plugin\AbstractPlugin {
	public $prefixId      = 'tx_igcashbackregister_pi1';		// Same as class name
	public $scriptRelPath = 'pi1/class.tx_igcashbackregister_pi1.php';	// Path to this script relative to the extension dir.
	public $extKey        = 'ig_cashback_register';	// The extension key.
	public $pi_checkCHash = FALSE;
    private $hash_string = ' j3jlL74%k2jh)=h4HDL3.,';
	


    function generatePassword($len = 8, $list = '23456789ABCDEFGHJKMNPQRSTUVWXYZ') {
        $str = '';
        if (is_numeric ($len) && !empty ($list)) {
            mt_srand ((double) microtime () * 1000000);
            while (strlen ($str) < $len) {
                $str .= $list[mt_rand (0, strlen ($list)-1)];
            }
        }
        return $str;
    }

    function createuser($email, $password, $newsleter) {

        $insertArray = array(
                             'pid'               => $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'settings_pidUsers', 'sThanks'),
                             'usergroup'         => $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'settings_usergroup', 'sThanks'),
                             'username'          => $email,
                             'password'          => $password,
                             'email'             => $email,
                             'disable'           => 0,
                             'tstamp'            => time(),
                             'crdate'            => time(),
                             );
        if ( $newsleter ) {
            $insertArray['module_sys_dmail_newsletter'] = 1;
            $insertArray['module_sys_dmail_html'] = 1;

        }
           
        $res = $GLOBALS['TYPO3_DB']->exec_INSERTquery('fe_users', $insertArray);

    }


    function sendmail($email, $password, $valid_to) {
        
        $endtime= date("d.m.Y - H:i", $valid_to);


        $msg = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'email_text', 'sThanks');
        
        $msg = str_replace('###USERNAME###',$email,$msg);
        $msg = str_replace('###PASSWORD###',$password,$msg);

        $username_password = '<table><tr><td style="font-size:10pt;font-family:arial;padding-left: 0;">Benutzername:</td><td>&nbsp;</td><td style="font-size:10pt;font-family:arial;;padding-left: 0;">'.htmlspecialchars($email).'</td></tr>
<tr><td style="font-size:10pt;font-family:arial;;padding-left: 0;">Passwort:</td><td>&nbsp;</td><td style="font-size:10pt;font-family:arial;;padding-left: 0;">'.htmlspecialchars($password).'</td></tr></table>';
        $msg = str_replace('###USERNAME_PASSWORD###',$username_password,$msg);

        $msg = str_replace('###LOGIN_LINK###','<a href="https://www.happysmart.ch/de/cashback/login.html">https://www.happysmart.ch/de/cashback/login.html</a>',$msg);
        $msg = str_replace('###EMAIL_LINK###','<a href="mailto:'.$this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'email_from', 'sThanks').'">'.$this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'email_from', 'sThanks').'</a>',$msg);



        // Mail Verschicken
        $cObj = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance ( "TYPO3\CMS\Frontend\ContentObject\ContentObjectRenderer" );
        $parseFunc = $GLOBALS ['TSFE']->tmpl->setup ['lib.'] ['parseFunc_RTE.'];
        $msg =  $cObj->parseFunc ( $msg, $parseFunc );


        $mail = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('t3lib_mail_message');
        $body = '<html>'.$this->html_head.'<body><div><img src="'.$mail->embed(Swift_Image::fromPath('fileadmin/images_layouts/logo_weiss_email.gif')).'" /></div><div style="font-size:10pt;font-family:arial;">' .$msg. '</div></body></html>';
        $mail->setFrom(array($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'email_from', 'sThanks')));
        $mail->setTo(array($email));
        $mail->setSubject($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'email_subject', 'sThanks'));
        $mail->setBody($body, 'text/html');
        $mail->send();

        $mail->setTo(array('cashback@happysmart.ch'));
        $mail->send();

        /*        $this->htmlMail = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('t3lib_htmlmail');
        $this->htmlMail->start();
        $this->htmlMail->recipient = $email;
        $this->htmlMail->subject = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'email_subject', 'sThanks');
        $this->htmlMail->from_email = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'email_from', 'sThanks');

        $body = '<html>'.$this->html_head.'<body><div style="font-size:10pt;font-family:arial;">' .$msg. '</div></body></html>';
        $this->htmlMail->setHTML(  $this->htmlMail->encodeMsg ( $body ));
        //print('MSG<br />'.$msg.'<br />END<br />');
        $this->htmlMail->send($email);
        */

    }


    function get_register_form() {
        $dam = tx_dam_db::getReferencedFiles ( 'tt_content', $this->id, 'ig_cashback_register_bild_links' );
        $bild = '';
        foreach ( ( array ) $dam ['files'] as $df ) {
            $bild =$df;
        }

        $ueberschrift_gross = str_replace("\n",'<br />',htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'ueberschrift_gross')));
        if ($ueberschrift_gross) {
        $content ='<div class="register_header">';

        if ($bild) {
/*            $content .= '<div class="register_header_left">
<img src="'.$bild.'" />
</div>';*/
        }

$content .= '<div class="register_header_right">
<h1 class="register_header">
'.$ueberschrift_gross.'
</h1>
</div>
        <div class="header_border_bottom">&nbsp;</div>
</div>';
        }



		$content .= '
<div class="cashback_temp_new">
<h3 class="cashback_login">'.htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'ueberschrift_rot')).'</h3>
'.tslib_pibase::pi_RTEcssText($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'einleitungstext')).'';
        if ($this->errors) {
            $content .= '<div class="register-msg-error floatbox">';
            if ($this->error_user_exists) {
                $link = $this->pi_getPageLink(2327, '', array( 'tx_felogin_pi1[forgot]' => '1' ) );
                $content .= '<div class="error-line">E-Mail Adresse existiert bereits. &nbsp;<a href="' . $link .'" class="link-passwort-vergessen">Passwort vergessen?</a></div>';

            }
            if ($this->error_email)
                $content .= '<div class="error-line">Ungültige E-Mail-Adresse</div>';
            if ($this->error_agb)
                $content .= '<div class="error-line">Sie müssen die AGB bestätigen</div>';

            $content .= '</div>';
        }


        $action_id = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'settings_pidActionLink', 'sThanks');
        $content .= '<form action="' . $this->pi_getPageLink( $action_id>0 ? $action_id : $GLOBALS['TSFE']->id ) . '" method="post">
<input type="hidden" name="' . $this->prefixId . '[sendcode]" value="'.$this->sendcode.'" />
<fieldset>
<div class="floatbox cashback_register_email'. ( $this->error_email ? ' anmeldung-error' : '' ) .'">
<label class="reg-label">'.htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'text_email')).'</label>
<div class="reg-input"><input type="text" name="' . $this->prefixId . '[e]" value="' . htmlspecialchars($this->piVars['e']) . '" /></div>
</div>
<div class="cahback_register_checkbox'. ( $this->error_agb ? ' anmeldung-error' : '' ) .'">
<input type="checkbox" name="' . $this->prefixId . '[agb]" value="1" '.($this->piVars['agb']==1 ? 'checked="checked"' : '').' /><span class="checkbox_text">'.htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'text_agb')) .' <a href="'.$this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'agb_link').'" target="_blank">' . htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'text_agb_link')).'</a></span>
</div>
<div class="cahback_register_checkbox">
<input type="checkbox" name="' . $this->prefixId . '[newsletter]" value="1" '.($this->piVars['newsletter']==1 ? 'checked="checked"' : '').' /><span class="checkbox_text">'.htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'text_newsletter')).'</span>
</div>
<div id="register-submit">
<input type="submit" name="submit" value="'.htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'text_knopf')).'" />
 </div>
</fieldset>
</form>
<br />
</div>

';

        return $content;
    }

    function get_register_send_mail() {

        // Send Mail
        $email = $this->piVars['e'];
        $password = $this->generatePassword();
        $newsletter = intval($this->piVars['newsletter']);

        $this->createuser($email, $password, $newsletter);
        $this->sendmail($email, $password, $newsletter);

        // Create User


        $content = '<div class="cashback_temp_new">
<h3 class="cashback_login">'.htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'ueberschrift_rot', 'sThanks')).'</h3>
'.tslib_pibase::pi_RTEcssText($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'einleitungstext', 'sThanks')).'
</div>';

        return $content;
    }

	/**
	 * The main method of the Plugin.
	 *
	 * @param string $content The Plugin content
	 * @param array $conf The Plugin configuration
	 * @return string The content that is displayed on the website
	 */
	public function main($content, array $conf) {
		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
        $this->pi_initPIflexForm();
        
        $this->pi_USER_INT_obj=1;

        $this->id = $this->cObj->data ['_LOCALIZED_UID']  ? $this->cObj->data ['_LOCALIZED_UID'] : $this->cObj->data ['uid'];

        $t = round(strftime('%s')/3600);
        
        $this->sendcode = md5($t.$this->hash_string);
        $this->sendcode_old = md5(($t-1).$this->hash_string);
        


        $send=0;
        $this->errors = 0;
        $this->error_email = 0;
        $this->error_agb = 0;
        $this->error_user_exists = 0;

        if ($this->piVars['sendcode'] && ($this->piVars['sendcode']==$this->sendcode || $this->piVars['sendcode']==$this->sendcode_old)) {
            if (!filter_var($this->piVars['e'],FILTER_VALIDATE_EMAIL))
                $this->error_email = 1;
            
            if ( ! $this->piVars['agb']==1 )
                $this->error_agb = 1;

            // Existiert der Benutzer schon
            $email=$this->piVars['e'];
            if ($this->error_email==0) {
                $con=$GLOBALS['TYPO3_DB']->exec_SELECTquery( 'uid', 'fe_users', "deleted = 0 AND email=".$GLOBALS['TYPO3_DB']->fullQuoteStr($email,'fe_users')."", null,  null, null );
                $row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc( $con );

                if (!empty($row)) {
                    $update_tmp=$GLOBALS['TYPO3_DB']->exec_UPDATEquery('fe_users',"deleted = 0 AND email=". $GLOBALS['TYPO3_DB']->fullQuoteStr($email,'fe_users')."", array( 'endtime' => 0));
                    $this->error_user_exists = 1;                
                }
            }
            
            $this->errors = $this->error_email || $this->error_agb || $this->error_user_exists;
            
            $send=1;
        }


        //echo('errors:'.$this->errors.' send:'.$send.'<br />');
        if (!$this->errors && $send==1) {
            $content = $this->get_register_send_mail();
        } else {
            $content = $this->get_register_form();
        }

		return $this->pi_wrapInBaseClass($content);
	}
}



if (defined('TYPO3_MODE') && isset($GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['XCLASS']['ext/ig_cashback_register/pi1/class.tx_igcashbackregister_pi1.php'])) {
	include_once($GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['XCLASS']['ext/ig_cashback_register/pi1/class.tx_igcashbackregister_pi1.php']);
}

?>